package logic

import (
	"GtDataStore/common/xerr"
	"context"
	"github.com/pkg/errors"

	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type ChangeTypeItemHistoryDataLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewChangeTypeItemHistoryDataLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ChangeTypeItemHistoryDataLogic {
	return &ChangeTypeItemHistoryDataLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *ChangeTypeItemHistoryDataLogic) ChangeTypeItemHistoryData(in *pb.ItemHistoryDataByTimeReq) (*pb.ChangeTypeItemHistoryDataResp, error) {
	LastData, err := l.svcCtx.ItemHistoryData.QueryHistoryDataLastByTime(l.ctx, in)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrCode(xerr.DB_ERROR), "model QueryHistoryDataLastByTime get data err:%v", err)
	}
	return &pb.ChangeTypeItemHistoryDataResp{
		Value: LastData.Val,
	}, nil
}
