package logic

import (
	"GtDataStore/common/xerr"
	"context"
	"github.com/pkg/errors"

	"GtDataStore/app/cmd/organization/internal/svc"
	"GtDataStore/app/cmd/organization/pb"

	"github.com/zeromicro/go-zero/core/logx"
)

type ItemHistoryDataForChartLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewItemHistoryDataForChartLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ItemHistoryDataForChartLogic {
	return &ItemHistoryDataForChartLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *ItemHistoryDataForChartLogic) ItemHistoryDataForChart(in *pb.ItemHistoryDataForChartReq) (*pb.ItemHistoryDataForChartResp, error) {
	modeList, err := l.svcCtx.ItemHistoryData.QueryHistoryDataForChart(l.ctx, in)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrCode(xerr.DB_ERROR), "model QueryHistoryDataForChart get data err:%v", err)
	}
	return &pb.ItemHistoryDataForChartResp{List: modeList}, nil
}
